extern crate mlua;

use mlua::Lua as LuaContext;

pub trait ScriptLang {
    fn init(&mut self);
    fn update(&mut self, delta: f32);
}

pub struct Lua {
    ctx: LuaContext,
}

impl Lua {
    pub fn new() -> Self {
	let ctx = LuaContext::new();
	Lua {
	    ctx,
	}
    }
}

impl ScriptLang for Lua {
    fn init(&mut self) {
	let path = std::path::Path::new("main.lua");
	let buf = std::fs::read(&path).expect("Could not find main.lua");
	self.ctx.load(&buf).exec();
    }

    fn update(&mut self, delta: f32) {
	todo!();
    }
}
